@echo off
setlocal

if ""%1"" == ""setup"" goto doSetup
if ""%1"" == ""run"" goto doRun
if ""%1"" == ""start"" goto doStart
if ""%1"" == ""bash"" goto doBash
if ""%1"" == ""cli"" goto docli
if ""%1"" == ""logs"" goto doLogs
if ""%1"" == ""stop"" goto doStop
if ""%1"" == ""pull"" goto doPull
if ""%1"" == ""PHONY"" goto doPHONY
if ""%1"" == ""eject"" goto doEject

echo Usage: build ( commands ...)
echo commands:
echo setup          init installation
echo run            use docker-compose command to start the xswitch container with detached running
echo start          use docker-compose command to start the xswitch container with foreground running
echo bash           go into the xswitch container with bash
echo cli            go into the xswitch container with fs_cli
echo logs           catch  the xswitch container  logs
echo stop           use docker-compose command to stop the xswitch container
echo pull           get the xswitch image 
echo PHONY          get the xswitch container's config
echo eject          tips
goto end 

:doSetup
    if not exist .env (
        copy env-win.example .env
        echo hello
        mkdir .\data
        copy xtra_config.lua.example xtra_config.lua
        move xtra_config.lua data/xtra_config.lua
        mkdir .\data\pgdata
        mkdir .\data\storage\upload
        mkdir data\storage\recordings
        mkdir data\storage\blocks
        curl -u xswitch:password "https://xswitch.cn/download/music2.0.tar.gz" --output music2.0.tar.gz
        tar -zxvf music2.0.tar.gz -C data\storage\upload\ && del music2.0.tar.gz
        curl -u xswitch:password "https://xswitch.cn/download/sounds2.0.tar.gz" --output sounds2.0.tar.gz
        tar -zxvf sounds2.0.tar.gz -C data\ && del sounds2.0.tar.gz
    )
    goto end
:doRun
	docker compose -f docker-compose-win.yml up -d
    goto end

:doStart
	docker compose -f docker-compose-win.yml up
    goto end

:doBash
	docker exec -it xswitch bash
    goto end

:docli
	docker exec -it xswitch fs_cli
    goto end

:doLogs
	docker logs -f --tail=100 xswitch
    goto end

:doStop
	docker compose -f docker-compose-win.yml down
    goto end

:doPull
	docker pull ccr.ccs.tencentyun.com/free/xswitch-community:6.1.2-bookworm
    goto end

:doPHONY
	docker cp xswitch:/usr/local/freeswitch/conf .
    goto end

:doEject
	echo conf copied to local dir, please edit docker-compose.yml to use it
    goto end
:end
